/*
	This file is part of VVV (Virtual Volumes View)

	Copyright (C) 2007, the VVV Development team

	Author: Fulvio Senore

    VVV is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    VVV is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with VVV; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        catalog_volume.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     31/12/2006 18:42:48
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// Generated by DialogBlocks (unregistered), 31/12/2006 18:42:48

#ifndef _CATALOG_VOLUME_H_
#define _CATALOG_VOLUME_H_

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma interface "catalog_volume.h"
#endif

/*!
 * Includes
 */

////@begin includes
////@end includes

#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/listbox.h>
#include <wx/button.h>
#include "data_interface/base_db.h"
#include "data_interface/db_null.h"
#include "data_interface/files.h"
#include "window_position.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CDIALOGCATALOGVOLUME_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CDIALOGCATALOGVOLUME_TITLE _("Catalog volume")
#define SYMBOL_CDIALOGCATALOGVOLUME_IDNAME ID_DIALOG_CATALOG_VOLUME
#define SYMBOL_CDIALOGCATALOGVOLUME_SIZE wxSize(400, 300)
#define SYMBOL_CDIALOGCATALOGVOLUME_POSITION wxDefaultPosition
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif

/*!
 * CDialogCatalogVolume class declaration
 */

class CDialogCatalogVolume: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CDialogCatalogVolume )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CDialogCatalogVolume( );
    CDialogCatalogVolume( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGCATALOGVOLUME_IDNAME, const wxString& caption = SYMBOL_CDIALOGCATALOGVOLUME_TITLE, const wxPoint& pos = SYMBOL_CDIALOGCATALOGVOLUME_POSITION, const wxSize& size = SYMBOL_CDIALOGCATALOGVOLUME_SIZE, long style = SYMBOL_CDIALOGCATALOGVOLUME_STYLE );

	// destructor
    ~CDialogCatalogVolume( );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGCATALOGVOLUME_IDNAME, const wxString& caption = SYMBOL_CDIALOGCATALOGVOLUME_TITLE, const wxPoint& pos = SYMBOL_CDIALOGCATALOGVOLUME_POSITION, const wxSize& size = SYMBOL_CDIALOGCATALOGVOLUME_SIZE, long style = SYMBOL_CDIALOGCATALOGVOLUME_STYLE );

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CDialogCatalogVolume event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_VOLUME_BROWSE
    void OnVolumeBrowseClick( wxCommandEvent& event );

#if defined(__WXMSW__)
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_GET_VOLUME_NAME
    void OnGetVolumeNameClick( wxCommandEvent& event );

#endif
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
    void OnHelpClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CATALOG
    void OnButtonCatalogClick( wxCommandEvent& event );

////@end CDialogCatalogVolume event handler declarations

////@begin CDialogCatalogVolume member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CDialogCatalogVolume member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

	void SetCatalogAudioMetadata( bool doCatalog ) { m_CatalogAudioMetadata = doCatalog; }

////@begin CDialogCatalogVolume member variables
    wxTextCtrl* m_VolumePath;
    wxButton* m_VolumeBrowse;
    wxTextCtrl* m_VolumeName;
#if defined(__WXMSW__)
    wxButton* m_GetVolumeNameButton;
#endif
    wxButton* m_HelpButton;
    wxButton* m_CatalogButton;
    wxButton* m_CloseButton;
    wxStaticText* m_CurrentFolder;
    wxListBox* m_HistoryListBox;
    /// Control identifiers
    enum {
        ID_DIALOG_CATALOG_VOLUME = 10007,
        ID_VOLUME_PATH = 10008,
        ID_VOLUME_BROWSE = 10009,
        ID_VOLUME_NAME = 10010,
        ID_GET_VOLUME_NAME = 10094,
        ID_BUTTON_CATALOG = 10095,
        ID_CURRENT_FOLDER = 10096,
        ID_LISTBOX_HISTORY = 10097
    };
////@end CDialogCatalogVolume member variables

private:

	// enable or disable all controls, used while cataloging to avoid recursion
	void EnableDisableControls( bool enabled );

	CWindowPosition m_WindowPosition;

	// the name read directly from the volume (useful if the user will change it)
	wxString m_realVolumeName;

	bool m_CatalogAudioMetadata;

};

#endif
    // _CATALOG_VOLUME_H_
